#lang typed/racket

;(: factorial (-> Number Number))
#|
(define (factorial n)
  (if (= n 0) 1
        (* n (factorial (- n 1)))))
;(: if (-> Bool Number Number))
(define (if c then-branch else-branch)
  (cond [c then-branch]
        [else else-branch]))

(factorial 1000)
-> (if (= 1000 0) 1
        (* 1000 (factorial (- 1000 1))))
-> (if #f 1 (* 1000 (factorial 999)))
-> (if #f 1 (* 1000 (if #f 1
        (* 1000 (factorial 998)))))
...
-----
(factorial 1)
-> (if (= 1 0) 1
        (* 1 (factorial (- 1 1))))
-> (if #f 1 (* 1 (factorial 0)))
-> (if #f 1 (* 1
    (if (= 0 0) 1
        (* 0 (factorial (- 0 1))))
  ))
-> (if #f 1 (* 2 (if # 1
        (* 0 (factorial -1)))))
|#
;;;;;;;;;;;;;;;; VERSION 2 ;;;;;;;;;;;;;;;;;;;;
(: if (All [T] (-> Boolean (-> T) (-> T) T)))
(define (if c then-branch else-branch)
  (cond [c (then-branch)]
        [else (else-branch)]))

(: factorial1 (-> Number Number))
(define (factorial1 n)
  (define (then-branch)
    1
  )
  (define (else-branch)
    (* n (factorial1 (- n 1)))
  )
  (if (= n 0) then-branch else-branch)
)

(: factorial2 (-> Number Number))
(define (factorial2 n)
  (if (= n 0)
    (lambda () 1)
    (lambda () (* n (factorial2 (- n 1)))))
)
(: factorial3 (-> Number Number))
(define (factorial3 n)
  (if (= n 0)
    (thunk 1)
    (thunk (* n (factorial2 (- n 1))))
  )
)

(: slow (-> Number))
(define slow
  (thunk
    (displayln "Called (slow)")
    (sleep 2)
    (exact-ceiling (* (random) 100))
  )
)
(slow)   ; Outputs: Called (slow)
(slow)   ; Outputs: Called (slow)

(: fast (Promise Number))
(define fast
  (delay
    (displayln "Called (fast)")
    (sleep 2)
    (exact-ceiling (* (random) 100))
  )
)
(list
  (force fast)
  (force fast)
  (force fast)
)

;; (: g (-> Number))
;; (define f
;;   (thunk
;;     (displayln "Called (f)")
;;     0
;;   )
;; )




